using System;
using SlatedGameToolkit.Framework.Logging;
using SlatedGameToolkit.Tools.CommandSystem.Exceptions;

namespace SlatedGameToolkit.Tools.CommandSystem.Interaction
{
    public class SingleConsoleInteraction : IInteractable
    {
        private bool interacted;
        private string oneTime;
        public SingleConsoleInteraction(string oneTime) {
            this.oneTime = oneTime;
        }

        public LogLevel Level => LogLevel.DEBUG;

        public string Listen()
        {
            if (interacted) throw new FatalUsageException("Command attempted to request for more information. This generally occurs if the command being ran requires more user input.");
            interacted = true;
            return oneTime;
        }

        public void LogMesesage(string message, DateTime time, LogLevel level)
        {
            Console.SetCursorPosition(0, Console.CursorTop);
            Console.WriteLine(string.Format("Game Engine [{0}] [{1}]: \n{2}", level, time.ToString(), message));
        }

        public void Separate()
        {
            Console.WriteLine();
        }

        public void Tell(string message)
        {
            Console.WriteLine(message);
        }
    }
}